﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Input;
using Telerik.Windows.Controls;

namespace BindingToDynamicData
{
    public class ViewModel : ViewModelBase
    {
        private ObservableCollection<MenuItem> menuItems;

        public ObservableCollection<MenuItem> MenuItems
        {
            get
            {   
                if(this.menuItems == null)
                {
                    this.menuItems = this.GetMenuItems();
                }
                return this.menuItems;
            }
        }

        private Key cutkey;

        public Key CutKey
        {
            get { return cutkey; }
            set { cutkey = value; this.OnPropertyChanged("CutKey"); }
        }

        private Key copyKey;

        public Key CopyKey
        {
            get { return copyKey; }
            set { copyKey = value; this.OnPropertyChanged("CopyKey"); }
        }

        private Key pasteKey;

        public Key PasteKey
        {
            get { return pasteKey; }
            set { pasteKey = value; this.OnPropertyChanged("PasteKey"); }
        }

        public ModifierKeys cutModifier;

        public ModifierKeys CutModifier
        {
            get { return cutModifier; }
            set { cutModifier = value; this.OnPropertyChanged("CutModifier"); }
        }

        public ModifierKeys copyModifier;

        public ModifierKeys CopyModifier
        {
            get { return copyModifier; }
            set { copyModifier = value; this.OnPropertyChanged("CopyModifier"); }
        }

        public ModifierKeys pasteModifier;

        public ModifierKeys PasteModifier
        {
            get { return pasteModifier; }
            set { pasteModifier = value; this.OnPropertyChanged("PasteModifier"); }
        }

        private ICommand cutCommand;

        public ICommand CutCommand
        {
            get { return cutCommand; }
            set { cutCommand = value; this.OnPropertyChanged("CutCommand"); }
        }
        private ICommand copyCommand;

        public ICommand CopyCommand
        {
            get { return copyCommand; }
            set { copyCommand = value; this.OnPropertyChanged("CopyCommand"); }
        }
        private ICommand pasteCommand;

        public ICommand PasteCommand
        {
            get { return pasteCommand; }
            set { pasteCommand = value; this.OnPropertyChanged("PasteCommand"); }
        }


        public ViewModel()
        {
            this.PasteCommand = new DelegateCommand(OnExecutePaste);
            this.CopyCommand = new DelegateCommand(OnExecuteCopy);
            this.CutCommand = new DelegateCommand(OnExecuteCut);
        }

        private void OnExecuteCut(object obj)
        {
            MessageBox.Show("My Cut Command");
        }

        private void OnExecuteCopy(object obj)
        {
            MessageBox.Show("My Copy Command");
        }

        private void OnExecutePaste(object obj)
        {
            MessageBox.Show("My Paste Command");
        }

        public ObservableCollection<MenuItem> GetMenuItems()
        {
            ObservableCollection<MenuItem> items = new ObservableCollection<MenuItem>();
            MenuItem copyItem = new MenuItem()
            {
                IconUrl = new Uri("Images/copy.png", UriKind.Relative),
                Text = "Copy",
                Command = ApplicationCommands.Copy
            };
            items.Add(copyItem);
            MenuItem pasteItem = new MenuItem()
            {
                IconUrl = new Uri("Images/paste.png", UriKind.Relative),
                Text = "Paste",
                Command = ApplicationCommands.Paste
            };
            items.Add(pasteItem);
            MenuItem cutItem = new MenuItem()
            {
                IconUrl = new Uri("Images/cut.png", UriKind.Relative),
                Text = "Cut",
                Command = ApplicationCommands.Cut
            };
            items.Add(cutItem);

            return items;
        }

    }
}
